"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrapTypeahead = require("react-bootstrap-typeahead");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_OPTIONS = {
  required: false,
  labelKey: "name",
  minLength: 3,
  placeholder: "Search..."
};

var TypeaheadField = function (_Component) {
  _inherits(TypeaheadField, _Component);

  function TypeaheadField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TypeaheadField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TypeaheadField.__proto__ || Object.getPrototypeOf(TypeaheadField)).call.apply(_ref, [this].concat(args))), _this), _this.handleSelectionChange = function (events) {
      if (events.length > 0) {
        var mapping = _this.props.uiSchema.typeaheadOptions.mapping;

        var schemaEvents = mapping ? events.map(function (val) {
          return _defineProperty({}, mapping, val);
        }) : events;
        _this.props.onChange(schemaEvents);
        setTimeout(function () {
          if (_this.refs.typeahead) {
            _this.refs.typeahead.getInstance().clear();
          }
        }, 0);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TypeaheadField, [{
    key: "render",
    value: function render() {
      var typeaheadOptions = this.props.uiSchema.typeaheadOptions;


      var typeConf = Object.assign({}, DEFAULT_OPTIONS, typeaheadOptions);
      typeConf.onChange = this.handleSelectionChange;
      typeConf.labelKey = (0, _utils.mapLabelKey)(typeaheadOptions.labelKey);
      typeConf.ref = "typeahead";

      return _react2.default.createElement(_reactBootstrapTypeahead.Typeahead, typeConf);
    }
  }]);

  return TypeaheadField;
}(_react.Component);

if ((0, _utils.isDevelopment)()) {
  TypeaheadField.propTypes = {
    schema: _propTypes2.default.object.isRequired,
    uiSchema: _propTypes2.default.shape({
      genTypeahead: _propTypes2.default.shape({
        options: _propTypes2.default.array.required
      })
    })
  };
}

exports.default = TypeaheadField;